# DBus-C++

## Desktop Communication Bus System

libdbus-c-- Documentation 0.9.0

- Files
- Data Structures
- Globals
- Main Page

Classes | Namespaces | Macros | Typedefs
interface.h File Reference
`#include <string>`
`#include <map>`
`#include "api.h"`
`#include "util.h"`
`#include "types.h"`
`#include "message.h"`
Include dependency graph for interface.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes

struct | DBus::PropertyData
class | DBus::AdaptorBase
class | DBus::ProxyBase
class | DBus::Interface
class | DBus::InterfaceAdaptor
class | DBus::InterfaceProxy

## Namespaces

namespace | DBus

## Macros

#define | register_method(interface, method, callback)
#define | bind_property(variable, type, can_read, can_write)
#define | connect_signal(interface, signal, callback)

## Typedefs

typedef std::map< std::string, PropertyData > | DBus::PropertyTable
typedef std::map< std::string, InterfaceAdaptor * > | DBus::InterfaceAdaptorTable
typedef std::map< std::string, InterfaceProxy * > | DBus::InterfaceProxyTable
typedef std::map< std::string, Slot< Message, const CallMessage & > > | DBus::MethodTable
typedef std::map< std::string, Slot< void, const SignalMessage & > > | DBus::SignalTable

## Macro Definition Documentation

## ◆ bind_property

#define bind_property | ( |  | variable,
|  |  | type,
|  |  | can_read,
|  |  | can_write )

Value:
InterfaceAdaptor::_properties[ #variable ].read = can_read; \
InterfaceAdaptor::_properties[ #variable ].write = can_write; \
InterfaceAdaptor::_properties[ #variable ].sig = type; \
variable.bind(InterfaceAdaptor::_properties[ #variable ]);

Definition at line 184 of file interface.h.

## ◆ connect_signal

#define connect_signal | ( |  | interface,
|  |  | signal,
|  |  | callback )

Value:
InterfaceProxy::_signals[ #signal ] = \
new ::DBus::Callback< interface, void, const ::DBus::SignalMessage &>(this, & interface :: callback);

Definition at line 190 of file interface.h.

## ◆ register_method

#define register_method | ( |  | interface,
|  |  | method,
|  |  | callback )

Value:
InterfaceAdaptor::_methods[ #method ] = \
new ::DBus::Callback< interface, ::DBus::Message, const ::DBus::CallMessage &>(this, & interface :: callback);

Definition at line 180 of file interface.h.

Referenced by DBus::IntrospectableAdaptor::IntrospectableAdaptor(), and DBus::PropertiesAdaptor::PropertiesAdaptor().